package uk.co.creativewax.sound
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.utils.ByteArray;
	
	import org.as3wavsound.WavSound;
	
	import uk.co.creativewax.pages.Pages;
	
	public class AudioPlayer extends Sprite
	{
		private var _player:WavSound;
		private var _fs:FileStream;
		private var _file:File;
		private var _bytes:ByteArray;
		private var _pages:Pages			= Pages.getInstance();	// Get an instance of Pages in the app
		
		
		public function AudioPlayer()
		{
			super();
		}
		
		
		
		// ______________________________________________
		// PUBLIC
		
		// Start recording audio
		public function togglePlaying():void
		{
			// Load sound to play
			_file		= File.applicationStorageDirectory.resolvePath(_pages.ID+".wav");	// resolve the path to the wav
			
			// reset the byte array
			_bytes		= new ByteArray();
			
			// Create filestream to load sound
			_fs			= new FileStream();
			_fs.addEventListener(Event.COMPLETE, onSoundLoaded);
			_fs.openAsync(_file, FileMode.UPDATE);
		}
		
		
		
		
		
		// ______________________________________________
		// PROTECTED
		
		
		
		
		// ______________________________________________
		// PRIVATE
		
		// Sound has finished loading
		private function onSoundLoaded(e:Event):void
		{
			// Check that data exists in the file stream
			if (_fs.bytesAvailable > 0)
			{
				_fs.readBytes(_bytes, 0, _fs.bytesAvailable);
				_bytes.position = 0;
			}
			
			// Start playing audio
			_player		= new WavSound(_bytes);
			_player.addEventListener(Event.COMPLETE, onSoundComplete);
			_player.play();
			
			// close file stream
			_fs.close();
			_fs.removeEventListener(Event.COMPLETE, onSoundLoaded);
			_fs		= null;
			_file	= null;
		}
		
		// Sound complete, lets clean up
		private function onSoundComplete(e:Event):void
		{
			_bytes.clear();
			_bytes	= null;
			_player	= null;
		}
		
		
		
		
		// ______________________________________________
		// GETTERS & SETTERS
	}
}